dbsql/test/scr013/chk.stats

121 lines
3.1 KiB
Text
Raw Permalink Normal View History

2007-03-10 19:04:07 +00:00
#!/bin/sh -
#
# Check to make sure all of the stat structure members are included in
# all of the possible formats.
# Top-level directory.
d=../..
docs=$d/docs_src
# Path names are from a top-level directory.
[ -f $d/README ] || {
echo 'FAIL: cannot find source distribution directory.'
exit 1
}
exitv=0
t=__tmp
trap 'rm -f $t1 IGNORE' 0 1 2 3 13 15
2007-03-10 19:04:07 +00:00
# Extract the field names for a structure from the dbsql.h file.
inc_fields()
{
sed -e "/struct $1 {/,/^};$/p" \
-e d < $d/src/dbsql.in |
2007-03-10 19:04:07 +00:00
sed -e 1d \
-e '$d' \
-e '/;/!d' \
-e 's/;.*//' \
-e 's/^[ ].*[ \*]//'
}
cat << END_OF_IGNORE > IGNORE
END_OF_IGNORE
# Check to make sure the elements of a structure from dbsql.h appear in
# the other files.
inc()
{
for i in `inc_fields $1`; do
if egrep -w $i IGNORE > /dev/null; then
echo " $1: ignoring $i"
continue
fi
for j in $2; do
if egrep -w $i $j > /dev/null; then
:;
else
echo " $1: $i not found in $j."
exitv=1
fi
done
done
}
inc "__db_bt_stat" "$d/tcl/tcl_db.c $d/btree/bt_stat.c $docs/db/db_stat.so"
inc "__db_h_stat" "$d/tcl/tcl_db.c $d/hash/hash_stat.c $docs/db/db_stat.so"
inc __db_lock_stat \
"$d/tcl/tcl_lock.c $d/lock/lock_stat.c $docs/lock/lock_stat.so"
inc __db_log_stat "$d/tcl/tcl_log.c $d/log/log_stat.c $docs/log/log_stat.so"
inc __db_mpool_fstat \
"$d/tcl/tcl_mp.c $d/mp/mp_stat.c $docs/memp/memp_stat.so"
inc __db_mpool_stat \
"$d/tcl/tcl_mp.c $d/mp/mp_stat.c $docs/memp/memp_stat.so"
inc "__db_qam_stat" \
"$d/tcl/tcl_db.c $d/qam/qam_stat.c $docs/db/db_stat.so"
inc __db_rep_stat \
"$d/tcl/tcl_rep.c $d/rep/rep_stat.c $docs/rep/rep_stat.so"
inc __db_seq_stat \
"$d/tcl/tcl_seq.c $d/sequence/seq_stat.c $docs/seq/seq_stat.so"
inc __db_txn_stat \
"$d/tcl/tcl_txn.c $d/txn/txn_stat.c $docs/txn/txn_stat.so"
# Check to make sure the elements from a man page appears in db.in.
man()
{
for i in `cat $t`; do
if egrep -w $i IGNORE > /dev/null; then
echo " $1: ignoring $i"
continue
fi
if egrep -w $i $d/src/dbsql.in > /dev/null; then
:;
else
echo " $1: $i not found in dbsql.h."
exitv=1
fi
done
}
sed -e '/m4_field(/!d' \
-e 's/.*m4_field[^,]*,[ ]*\([^,]*\).*/\1/' < $docs/db/db_stat.so > $t
man "checking db_stat.so against db.h"
sed -e '/m4_field(/!d' \
-e 's/.*m4_field[^,]*,[ ]*\([^,]*\).*/\1/' < $docs/lock/lock_stat.so > $t
man "checking lock_stat.so against db.h"
sed -e '/m4_field(/!d' \
-e 's/.*m4_field[^,]*,[ ]*\([^,]*\).*/\1/' < $docs/log/log_stat.so > $t
man "checking log_stat.so against db.h"
sed -e '/m4_field(/!d' \
-e 's/.*m4_field[^,]*,[ ]*\([^,]*\).*/\1/' < $docs/memp/memp_stat.so > $t
man "checking memp_stat.so against db.h"
sed -e '/m4_field(/!d' \
-e 's/.*m4_field[^,]*,[ ]*\([^,]*\).*/\1/' < $docs/rep/rep_stat.so > $t
man "checking rep_stat.so against db.h"
sed -e '/m4_field(/!d' \
-e 's/.*m4_field[^,]*,[ ]*\([^,]*\).*/\1/' < $docs/seq/seq_stat.so > $t
man "checking seq_stat.so against db.h"
sed -e '/m4_field(/!d' \
-e 's/.*m4_field[^,]*,[ ]*\([^,]*\).*/\1/' \
-e 's/__LB__.*//' < $docs/txn/txn_stat.so > $t
man "checking txn_stat.so against db.h"
exit $exitv